﻿
@model SampleTableServerSidePaging.Controllers.PagingMode
@{
    ViewData["Title"] = "MVC Paging";
}
@{
    var page_num = 0;
    List<(int, int)> pages = null;
    var current_page = 1;
    if (Model.Total > 0 && Model.Length > 0)
    {
        page_num = Model.Total / Model.Length;
        var mod = Model.Total % Model.Length;
        page_num = mod > 0 ? page_num + 1 : page_num;
        int start = 0;
        pages = new List<(int, int)>();
        for (int i = 1; i <= page_num; i++)
        {
            if (Model.Start == start) current_page = i;
            pages.Add((i, start));
            start += Model.Length;
        }
    }
}

<h1>MVC Server Side Paging</h1>

    @if (pages != null && current_page > 1)
    {
        <button class="btn-pagging" data-value="previous">Previous</button>
    }
    @foreach (var p in pages)
    {
        if (current_page == @p.Item1)
        {
            <button class="btn-pagging" disabled data-value="@p.Item2">@p.Item1</button>
        }
        else
        {
            <button class="btn-pagging" data-value="@p.Item2">@p.Item1</button>
        }
    }
    @if (pages != null && current_page < page_num)
    {
        <button class="btn-pagging" data-value="next">Next</button>
    }
    @{
        var from = Model.Start + 1;
        var to = Model.Start + Model.Length;
    }
    <p>@from - @to in @Model.Total</p>
    <div style="clear: both; height: 25px;"></div>
    <table class="table table-striped table-bordered" role="grid">
        <thead>
            <tr>
                <th>ID</th>
                <th>Name</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var item in Model?.Data)
            {
                <tr>
                    <td>@item.ID</td>
                    <td>@item.Name</td>
                </tr>
            }
        </tbody>
    </table>


    @section scripts{

        <script type="text/javascript">
        $('document').ready(function () {
            $('button.btn-pagging').on('click', function () {
                var start = $(this).data("value");
                if (start == "previous") {
                    start = @Model.Start - @Model.Length;
                } else if (start == "next") {
                     start = @Model.Start + @Model.Length;
                }
                window.location = "?start=" + start ;
            });
        });

        </script>
    }

